/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.factory.item;

import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumHand;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;

import buildcraft.lib.item.ItemBC_Neptune;

import buildcraft.factory.BCFactoryBlocks;
import buildcraft.factory.block.BlockWaterGel;
import buildcraft.factory.block.BlockWaterGel.GelStage;

public class ItemWaterGel extends ItemBC_Neptune {

    public ItemWaterGel(String id) {
        super(id);
        this.field_77777_bU = 16;
    }

    @Override
    public ActionResult<ItemStack> func_77659_a(World world, EntityPlayer player, EnumHand hand) {
        ItemStack stack = player.func_184586_b(hand);
        Vec3d start = player.func_174791_d().func_72441_c(0, player.func_70047_e(), 0);
        Vec3d look = player.func_70040_Z();
        Vec3d end = start.func_178787_e(look.func_186678_a(7));
        RayTraceResult ray = world.func_147447_a(start, end, true, false, true);

        if (ray == null || ray.func_178782_a() == null) {
            return new ActionResult<>(EnumActionResult.FAIL, stack);
        }

        Block b = world.func_180495_p(ray.func_178782_a()).func_177230_c();
        if (b != Blocks.field_150355_j) {
            return new ActionResult<>(EnumActionResult.FAIL, stack);
        }

        if (!player.field_71075_bZ.field_75098_d) {
            stack.func_190920_e(stack.func_190916_E() - 1);
        }

        // Same as ItemSnowball
        world.func_184148_a(null, player.field_70165_t, player.field_70163_u, player.field_70161_v,//
                SoundEvents.field_187797_fA, SoundCategory.NEUTRAL,//
                0.5F, 0.4F / (field_77697_d.nextFloat() * 0.4F + 0.8F));

        if (!world.field_72995_K) {
            world.func_175656_a(ray.func_178782_a(), BCFactoryBlocks.waterGel.func_176223_P().func_177226_a(BlockWaterGel.PROP_STAGE, GelStage.SPREAD_0));
            world.func_175684_a(ray.func_178782_a(), BCFactoryBlocks.waterGel, 200);

            // TODO: Snowball stuff

            // EntitySnowball entitysnowball = new EntitySnowball(world, player);
            // entitysnowball.setHeadingFromThrower(player, player.rotationPitch, player.rotationYaw, 0.0F, 1.5F, 1.0F);
            // world.spawnEntityInWorld(entitysnowball);
        }

        // player.addStat(StatList.getObjectUseStats(this));
        return new ActionResult<>(EnumActionResult.SUCCESS, stack);
    }

}
